/*******************************************************************************
 * Copyright (c) 2009 itemis AG (http://www.itemis.eu) and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *******************************************************************************/
package org.eclipse.emf.index.feeder;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.index.event.IndexChangeEvent;
import org.eclipse.emf.index.event.IndexChangeListener;

/**
 * @author Jan Khnlein - Initial contribution and API
 */
public class IndexChangeListenerImpl implements IndexChangeListener {

	List<IndexChangeEvent> events = new ArrayList<IndexChangeEvent>();
	
	public void indexChanged(IndexChangeEvent event) {
		events.add(event);
	}

	public List<IndexChangeEvent> getEvents() {
		return events;
	}
	
	public void clearEvents() {
		events.clear();
	}
}
